 %LIKELIHOOD FUNCTION

function [se_theta,zmle,Pmle]=func_var(theta0)

global M J N N1 K KX KZ R typeK n_theta X Z entry match;
 
%type 0's latent profit, without considering opponents' entry decisions
profit_k0=X*theta0(1:KX); 
normcdf_profit_k0=normcdf(profit_k0);
normpdf_profit_k0=normpdf(profit_k0);

%type 1's profit function
% citycitymatch'*normcdf(profit_k0): a M*1 vector, expected type-0 entrants for all M cities
% citymatch*citymatch'*normcdf(profit_k0); N*1, expected type-0 entrants into the city
% need to substract entering probablity of itself
%A=citymatch*citymatch'*normcdf_profit_k0-normcdf_profit_k0;
A=match*normcdf_profit_k0;

profit_k1=profit_k0+A*theta0(KX+1);

% create tau parameter (only needed for type 2 and above) 
% exp() to ensure that tau is non-negative
% note exp() increases really fast, and poisspdf(0,a very large number)=0 (rounding error in matlab)
tau=exp(Z*theta0((KX+2):n_theta));

profit=[profit_k0 profit_k1 zeros(N1,K-1)];

% for calculating gradients
gb1=ones(N1,1)+match*normpdf_profit_k0*theta0(KX+1);

gg1=A;

gb=[ones(N1,1) gb1 zeros(N1,K-1)];
gg=[zeros(N1,1) gg1 zeros(N1,K-1)];
gr=zeros(N1,K+1,KZ);

fi(:,1)=tau.^(0)/factorial(0);

for k=2:K,
    
    % a type k player thinks that there are k types of rivals (0, 1, to k-1) in the market 
    type=linspace(0,k-1,k);
    % f: type k's perceived distribution about rivals, from truncated poisson, a k*N1 matrix
    fi(:,k)=tau.^(k-1)/factorial(k-1);
     
    sum_fi=fi*ones(k,k);
    f=fi./sum_fi;
    
    %type k's profit function
    exptd_pr_rvls_k=normcdf(sum(profit(:,1:k).*f,2)); 
    A_k=match*exptd_pr_rvls_k;
    profit(:,k+1)=profit_k0+A_k*theta0(KX+1);    

    B=normpdf(sum(profit(:,1:k).*f,2));
    exptd_gb_k=sum(gb(:,1:k).*f,2).*B;
    gb(:,k+1)=ones(N1,1)+match*exptd_gb_k*theta0(KX+1);    
    
    exptd_gg_k=sum(gg(:,1:k).*f,2).*B;
    gg(:,k+1)=A_k+match*exptd_gg_k*theta0(KX+1);
    
    % for df_dr_k the derivative of exp() and Z is incorporated by chain rule
    df_dr_k=fi.*(ones(N1,1)*type);
    df_dr_k=df_dr_k./sum_fi-fi.*(df_dr_k*ones(k,k))./(sum_fi.^2);

    for zk=1:KZ,           
        exptd_gr_k=sum(gr(:,1:k,zk).*f+profit(:,1:k).*(df_dr_k.*(Z(:,zk)*ones(1,k))),2).*B;
        gr(:,k+1,zk)=match*exptd_gr_k*theta0(KX+1);    
    end;
    
    clear type f exptd_pr_rvls_k A_k B exptd_gb_k  exptd_gg_k exptd_gr_k df_dr_k;

end;

   fi_firm(:,1:K)=fi;
   fi_firm(:,K+1)=tau.^(K)/factorial(K);
   sum_fi_firm=fi_firm*ones(K+1,K+1);
   f_firm=fi_firm./sum_fi_firm;

pr_in=normcdf(sum(profit.*f_firm,2));

Lall=pr_in.*entry+(1-pr_in).*(1-entry);
L=-sum(log(Lall+0.00000001*(Lall==0))); 

% compute the gradients

d_common=(2*entry-1)./Lall;
B_K=normpdf(sum(profit.*f_firm,2));
gbeta=X'.*(sum(gb.*f_firm,2).*B_K.*d_common*ones(1,KX))';
ggama=(sum(gg.*f_firm,2).*B_K.*d_common)';
% d(poisspdf(x,namda)/d(namda)

df_dr=fi_firm.*(ones(N1,1)*typeK);
df_dr=df_dr./sum_fi_firm-fi_firm.*(df_dr*ones(K+1,K+1))./(sum_fi_firm.^2);

for zk=1:KZ,
    gra1(zk,:)=(sum(gr(:,:,zk).*f_firm,2).*B_K.*d_common)';
end;
gra2=Z'.*(sum(profit.*df_dr,2).*B_K.*d_common*ones(1,KZ))';
gra=gra1+gra2;

g=[-gbeta;-ggama;-gra];

%inform = 1/N*(g*g'); this is the information matrix
inform = g*g';  % for the asymptotic variance of theta, the 1/N cancelled out, var(theta)=inv(inform)/N
se_theta=sqrt(diag(inv(inform)));
zmle=theta0./se_theta;
Pmle=2*(1-normcdf(abs(zmle)));



    
