% col 5, table 4, NO market random effects
% M: # of markets
% J: # of CLECs
% N: # of CLEC-market observations
% K: # of steps
% X: regressors
% entry: dummy variable indicating entry or not
% citymatch: a N*M sparse matrix; row=CLEC-market pair, column=city


global M J N N1 K KX KZ R typeK n_theta X Z entry match;
K=8 % max type = 8. So there are 9 types of players from 0 to 8.
typeK=linspace(0,K,K+1);
N=size(data,1); 

% use full sample. Can start with a subsample for starting values
N1=N

disp('X=[1 pop/1000/1000  pct_black median_age hhsize pct_frgn_born inc/1000 pct_poverty gte rbc log(estab/1000) size_estab pct_manuf]')
X = [ones(N1,1)/10 data(1:N1,6)/1000 data(1:N1,7) data(1:N1,8)/100 data(1:N1,9)/10 data(1:N1,10) data(1:N1,11)/100 data(1:N1,14) data(1:N1,16:17)/10 log(data(1:N1,18)) data(1:N1,19)/100 data(1:N1,20)];
KX = size(X,2);

age_firm = data(1:N1,23); 
subsidiary = data(1:N1,24); 
private = data(1:N1,21); 
venture_capital= data(1:N1,22);
exp_m = data(1:N1,42); 
age_manager = data(1:N1,43); 
has_graddegree = data(1:N1,44); 
ug_usnew25 = data(1:N1,46); 
sat1400 = (data(1:N1,50) >= 1400); 
has_econbus = data(1:N1,51);
has_econbus5 = data(1:N1,52);
has_engineer = data(1:N1,53);

ln_exp_m = log(exp_m+1); ln_age_manager = log(age_manager+1);
ln_age_firm = log(age_firm + 1); age_firm_3_10 = (age_firm >= 3) .* (age_firm < 10); age_firm_above10 = (age_firm >=10);
i_exp_econ = ln_exp_m .* has_econbus5;

disp('Z = [1 ln_exp_m sat1400 has_econbus5 i_exp_econ has_engineer has_graddegree ln_age_firm subsidiary private venture_capital]')
Z =[ones(N1,1) ln_exp_m sat1400 has_econbus5 i_exp_econ has_engineer has_graddegree ln_age_firm subsidiary private venture_capital]/10;
KZ = size(Z,2);

scale = 1./[10 1 1 100 10 1 100 1 10 10 1 100 1 1 10*ones(1, size(Z,2))]';

entry=data(1:N1,5);
city_ID=data(1:N1,1);

M=max(city_ID);	%  # of cities where CLECs can potentially enter
citymatch=sparse(zeros(N1,M));
city_temp=sparse(ones(N1,1)*linspace(1, M, M));
citymatch=logical(city_temp==city_ID*ones(1,M));
match=citymatch*citymatch'-eye(N1);
clear city_temp;

n_theta=size(X,2)+1+size(Z,2);

theta0=[32.1593;-1.6554;3.4202;-14.4805;-19.9466;0.9444;1.6269;9.1071;20.3899;14.6336;2;5.5817;-2.7876;-0.9036;9.0820;0.8468;0.4243;1.8727;-0.7978;-0.3;0.6;0.6;-0.9;-1;0.1];

tau=exp(Z*theta0((KX+2):n_theta));
tau_initial=[min(tau) mean(tau) median(tau) max(tau) std(tau)]

tic
logL_g_r1(theta0)
toc
tic
logL_r1(theta0)
toc

%theta1=theta0+0.1*randn(size(theta0));
theta1=theta0;
options= optimset('Display', 'iter','TolX',0.005,'TolFun',1e-12,'MaxFunEvals',50000,'MaxIter',50000,'GradObj','on','LargeScale','on','FunValCheck','on','FinDiffType','central','DerivativeCheck','off'); 
tic
[theta,fval,exitflag,output,grad]=fminunc(@logL_g_r1,theta1,options) 
%[theta,fval,exitflag,output]=fminsearch(@logL_r1,theta1,options) 
% toc
% theta_g=theta;
% options= optimset('Display', 'iter','TolX',0.005,'TolFun',1e-8,'MaxFunEvals',50000,'MaxIter',50000,'FunValCheck','on'); 
% tic
% [theta,fval,exitflag,output]=fminsearch(@logL_r1,theta_g,options) 
% toc

% use analytical gradients to calculate std. errors: 
[se_theta_test,tmle_test,Pmle_test]=func_var(theta);
theta2=theta.*scale;
se_theta2=se_theta_test.*scale;
[theta2 se_theta2 tmle_test Pmle_test]

% use numerical gradeints to calculate std. errors: 
se_theta=secalc_Alex(N1,@indv_logL_r1,theta);
tmle=theta./se_theta;
Pmle=2*(1-tcdf(abs(tmle),N1));

tau=exp(Z*theta((KX+2):n_theta));
tau_show=[min(tau) mean(tau) median(tau) max(tau) std(tau)]

% evaluate the probability of entry for each potential entrant.
pr_in=indv_pr_in(theta);
se_theta=se_theta.*scale;
%[theta1 se_theta tmle Pmle]


