function [se] = secalc_Alex(n, fi, theta);
% n - number of observations
% &f - reference on the procedure to calculate individual ml
% theta - vector of estimates
% fder - matrix of first derivatives (two-sided)
% permutf - forward permutation
% permutb - backward permutation
fder = zeros(n, size(theta,1));
for i = 1:size(theta,1);
    permutf = theta;
    permutb = theta;
    permutf(i) = 1.00001*theta(i);
    permutb(i) = 0.99999*theta(i);
    fder(:,i) = (fi(permutf)-fi(permutb))/(permutf(i)-permutb(i));
end;
    if det(fder'*fder) == 0;
        se = zeros(size(theta,1),1);
    else;
        vcovscore = inv(fder'*fder);
        se = sqrt(diag(vcovscore));
    end; 
end